using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows.Forms;
 
namespace OlGetUserEmailExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("4BAAFEA0-AE94-4A8B-BBA8-FC7021FE7609"), ProgId("OlGetUserEmailExample.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

		private AddinExpress.MSO.ADXOlExplorerCommandBar adxOlExplorerCommandBar1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
		private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton2;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxOlExplorerCommandBar1 = new AddinExpress.MSO.ADXOlExplorerCommandBar(this.components);
			this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
			this.adxCommandBarButton2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			// 
			// adxOlExplorerCommandBar1
			// 
			this.adxOlExplorerCommandBar1.CommandBarName = "adxOlExplorerCommandBar1";
			this.adxOlExplorerCommandBar1.CommandBarTag = "264acaef-1be6-4f03-ad92-a4c880868cbf";
			this.adxOlExplorerCommandBar1.Controls.Add(this.adxCommandBarButton1);
			this.adxOlExplorerCommandBar1.Temporary = true;
			this.adxOlExplorerCommandBar1.UpdateCounter = 3;
			// 
			// adxCommandBarButton1
			// 
			this.adxCommandBarButton1.Caption = "Show SMTP Address of the current user";
			this.adxCommandBarButton1.ControlTag = "62178a03-adfa-470a-bd7e-cd00c635147c";
			this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton1.Temporary = true;
			this.adxCommandBarButton1.UpdateCounter = 2;
			this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
			// 
			// adxOlInspectorCommandBar1
			// 
			this.adxOlInspectorCommandBar1.CommandBarName = "SMTP Address";
			this.adxOlInspectorCommandBar1.CommandBarTag = "55e8f067-89fa-47aa-b158-f1428bee4499";
			this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton2);
			this.adxOlInspectorCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
			this.adxOlInspectorCommandBar1.Temporary = true;
			this.adxOlInspectorCommandBar1.UpdateCounter = 5;
			// 
			// adxCommandBarButton2
			// 
			this.adxCommandBarButton2.Caption = "Get SMTP Address";
			this.adxCommandBarButton2.ControlTag = "629afb10-cde2-4a4e-8042-40530aa266c7";
			this.adxCommandBarButton2.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton2.Temporary = true;
			this.adxCommandBarButton2.UpdateCounter = 2;
			this.adxCommandBarButton2.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton2_Click);
			// 
			// AddinModule
			// 
			this.AddinName = "OlGetUserEmailExample";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private Outlook._Application OutlookHost()
		{
			return (HostApplication as Outlook._Application);
		}

		private string GetSMTPAddress(string address, IntPtr addrBookPtr)
		{
			object addrBookObj = null;
			string smtpAddress = String.Empty;
			try
			{
				addrBookObj = Marshal.GetObjectForIUnknown(addrBookPtr);
				IAddrBook addrBook = addrBookObj as IAddrBook;
				if (addrBook != null)
				{
					IntPtr szPtr = IntPtr.Zero;
					IntPtr propValuePtr = Marshal.AllocHGlobal(16);
					IntPtr adrListPtr = Marshal.AllocHGlobal(16);

					Marshal.WriteInt32(propValuePtr, (int)MAPI.PR_DISPLAY_NAME);
					Marshal.WriteInt32(new IntPtr(propValuePtr.ToInt32() + 4), 0);
					szPtr = Marshal.StringToHGlobalAnsi(address);
					Marshal.WriteInt64(new IntPtr(propValuePtr.ToInt32() + 8), szPtr.ToInt32());

					Marshal.WriteInt32(adrListPtr, 1);
					Marshal.WriteInt32(new IntPtr(adrListPtr.ToInt32() + 4), 0);
					Marshal.WriteInt32(new IntPtr(adrListPtr.ToInt32() + 8), 1);
					Marshal.WriteInt32(new IntPtr(adrListPtr.ToInt32() + 12), propValuePtr.ToInt32());

					try
					{
						if (addrBook.ResolveName(0, MAPI.MAPI_DIALOG, null, adrListPtr) == MAPI.S_OK)
						{
							SPropValue spValue = new SPropValue();
							int pcount = Marshal.ReadInt32(new IntPtr(adrListPtr.ToInt32() + 8));
							IntPtr props = new IntPtr(Marshal.ReadInt32(new IntPtr(adrListPtr.ToInt32() + 12)));
							for(int i=0; i<pcount; i++)
							{
								IntPtr addrEntryPtr = IntPtr.Zero;
								IntPtr propAddressPtr = IntPtr.Zero;
								try
								{
									spValue = (SPropValue)Marshal.PtrToStructure(
										new IntPtr(props.ToInt32()+(16*i)), typeof(SPropValue));
									if (spValue.ulPropTag == MAPI.PR_ENTRYID)
									{
										uint objType = 0;
										uint cb = (uint)(spValue.Value&0xFFFFFFFF);
										IntPtr entryID = new IntPtr((int)(spValue.Value>>32));
										if (addrBook.OpenEntry(cb, entryID, IntPtr.Zero, 0, out objType, out addrEntryPtr) == MAPI.S_OK)
										{
											if (MAPI.HrGetOneProp(addrEntryPtr, MAPI.PR_EMS_AB_PROXY_ADDRESSES, out propAddressPtr) == MAPI.S_OK)
											{
												IntPtr emails = IntPtr.Zero;
												SPropValue addrValue = (SPropValue)Marshal.PtrToStructure(propAddressPtr, typeof(SPropValue));
												int acount = (int)(addrValue.Value&0xFFFFFFFF);
												IntPtr pemails = new IntPtr((int)(addrValue.Value>>32));
												for(int j=0; j<acount; j++)
												{
													emails = new IntPtr(Marshal.ReadInt32(new IntPtr(pemails.ToInt32()+(4*j))));
													smtpAddress = Marshal.PtrToStringAnsi(emails);
													if (smtpAddress.IndexOf("SMTP:") == 0)
													{
														smtpAddress = smtpAddress.Substring(5, smtpAddress.Length-5);
														break;
													}
												}
											}
										}
									}
								}
								catch
								{
								}
								finally
								{
									if (propAddressPtr != IntPtr.Zero)
										Marshal.Release(propAddressPtr);
									if (addrEntryPtr != IntPtr.Zero)
										Marshal.Release(addrEntryPtr);
								}
							}
						}
					}
					finally
					{
						if (szPtr != IntPtr.Zero)
							Marshal.FreeHGlobal(szPtr);
						if (propValuePtr != IntPtr.Zero)
							Marshal.FreeHGlobal(propValuePtr);
						if (adrListPtr != IntPtr.Zero)
							Marshal.FreeHGlobal(adrListPtr);
					}
				}
			}
			finally
			{
				if (addrBookObj != null)
					Marshal.ReleaseComObject(addrBookObj);
				if (addrBookPtr != IntPtr.Zero)
					Marshal.Release(addrBookPtr);
			}
			return smtpAddress;
		}

		private void adxCommandBarButton1_Click(object sender)
		{
			try
			{
				string email = String.Empty;
				Outlook._NameSpace ns = null;
				Outlook.Recipient recpt = null;
				IntPtr sessionPtr = IntPtr.Zero;
				try
				{
					ns = OutlookHost().Session;
					recpt = ns.CurrentUser;
					email = recpt.Address;
					if (MAPI.MAPIInitialize(IntPtr.Zero) == MAPI.S_OK)
					{
						MAPI.MAPILogonEx(0, null, null, MAPI.MAPI_EXTENDED | MAPI.MAPI_ALLOW_OTHERS, out sessionPtr);
						if (sessionPtr == IntPtr.Zero)
							MAPI.MAPILogonEx(0, null, null, MAPI.MAPI_EXTENDED | MAPI.MAPI_NEW_SESSION | MAPI.MAPI_USE_DEFAULT, out sessionPtr);

						if (sessionPtr != IntPtr.Zero)
						{
							object sessionObj = null;
							try
							{
								sessionObj = Marshal.GetObjectForIUnknown(sessionPtr);
								IMAPISession session = sessionObj as IMAPISession;
								if (session != null)
								{
									IntPtr addrBook = IntPtr.Zero;
									session.OpenAddressBook(0, IntPtr.Zero, MAPI.AB_NO_DIALOG, out addrBook);
									if (addrBook != IntPtr.Zero)
									{
										MessageBox.Show(GetSMTPAddress(email, addrBook));
									}
								}
							}
							finally
							{
								if (sessionObj != null)
									Marshal.ReleaseComObject(sessionObj);
							}
						}
					}
					else
						throw new ApplicationException("MAPI can not be initialized.");
				}
				finally
				{
					if (sessionPtr != IntPtr.Zero)
						Marshal.Release(sessionPtr);
					if (ns != null)
						Marshal.ReleaseComObject(ns);
					if (recpt != null)
						Marshal.ReleaseComObject(recpt);
				}
			}
			catch(Exception err)
			{
				MessageBox.Show(err.Message, err.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void adxCommandBarButton2_Click(object sender)
		{
			try
			{
				object currentItem = null;
				string email = String.Empty;
				Outlook.MailItem mail = null;
				Outlook._NameSpace ns = null;
				Outlook.Recipient recpt = null;
				IntPtr sessionPtr = IntPtr.Zero;
				Outlook._Inspector inspector = null;
				try
				{
					inspector = OutlookHost().ActiveInspector();
					currentItem = inspector.CurrentItem;
					mail = currentItem as Outlook.MailItem;

					if (mail == null) return;

					mail.Save();

					if (mail.Recipients.Count == 0) return;
					
					email = mail.Recipients.Item(1).Address;

					if (MAPI.MAPIInitialize(IntPtr.Zero) == MAPI.S_OK)
					{
						MAPI.MAPILogonEx(0, null, null, MAPI.MAPI_EXTENDED | MAPI.MAPI_ALLOW_OTHERS, out sessionPtr);
						if (sessionPtr == IntPtr.Zero)
							MAPI.MAPILogonEx(0, null, null, MAPI.MAPI_EXTENDED | MAPI.MAPI_NEW_SESSION | MAPI.MAPI_USE_DEFAULT, out sessionPtr);

						if (sessionPtr != IntPtr.Zero)
						{
							object sessionObj = null;
							try
							{
								sessionObj = Marshal.GetObjectForIUnknown(sessionPtr);
								IMAPISession session = sessionObj as IMAPISession;
								if (session != null)
								{
									IntPtr addrBook = IntPtr.Zero;
									session.OpenAddressBook(0, IntPtr.Zero, MAPI.AB_NO_DIALOG, out addrBook);
									if (addrBook != IntPtr.Zero)
									{
										MessageBox.Show(GetSMTPAddress(email, addrBook));
									}
								}
							}
							finally
							{
								if (sessionObj != null)
									Marshal.ReleaseComObject(sessionObj);
							}
						}
					}
					else
						throw new ApplicationException("MAPI can not be initialized.");
				}
				finally
				{
					if (sessionPtr != IntPtr.Zero)
						Marshal.Release(sessionPtr);
					if (ns != null)
						Marshal.ReleaseComObject(ns);
					if (recpt != null)
						Marshal.ReleaseComObject(recpt);
					if (currentItem != null)
						Marshal.ReleaseComObject(currentItem);
					if (inspector != null)
						Marshal.ReleaseComObject(inspector);
				}
			}
			catch(Exception err)
			{
				MessageBox.Show(err.Message, err.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
 
    }
}

